--- /dev/null
+#!/bin/bash
+#
+# Copyright (C) 2019 Michael Jeanson <mjeanson@efficios.com>
+#
+# This library is free software; you can redistribute it and/or modify it under
+# the terms of the GNU Lesser General Public License as published by the Free
+# Software Foundation; version 2.1 of the License.
+#
+# This library is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
+# details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with this library; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+TEST_DESC="UST - Namespace contexts change"
+
+CURDIR=$(dirname "$0")/
+TESTDIR=$CURDIR/../../..
+
+TESTAPP_PATH="$TESTDIR/utils/testapp"
+TESTAPP_NAME="gen-ust-events-ns"
+TESTAPP_BIN="$TESTAPP_PATH/$TESTAPP_NAME/$TESTAPP_NAME"
+NUM_EVENT=1000
+EVENT_NAME="tp:tptest"
+
+TESTS_PER_NS=16
+
+NUM_TESTS=$((TESTS_PER_NS * 5))
+
+source "$TESTDIR/utils/utils.sh"
+
+# MUST set TESTDIR before calling those functions
+
+function test_ns()
+{
+ local ns=$1
+
+ local session_name="${ns}_ns"
+ local chan_name="${ns}_ns"
+ local context_name="${ns}_ns"
+
+ local trace_path
+ local ns_inode
+ local file_sync_before_last
+ local file_sync_after_unshare
+
+ # Check if the kernel has support for this ns type
+ if [ ! -f "/proc/$$/ns/$ns" ]; then
+ skip 0 "System has no $ns namespace support" $TESTS_PER_NS
+ return
+ fi
+
+ # Get the current ns inode number
+ ns_inode=$(stat -c '%i' -L "/proc/$$/ns/$ns")
+ ok $? "Get current $ns namespace inode: $ns_inode" || ns_inode="invalid"
+
+ trace_path=$(mktemp -d)
+ file_sync_before_last=$(mktemp -u)
+ file_sync_after_unshare=$(mktemp -u)
+
+ start_lttng_sessiond
+
+ create_lttng_session_ok "$session_name" "$trace_path"
+ enable_ust_lttng_channel_ok "$session_name" "$chan_name"
+ add_context_ust_ok "$session_name" "$chan_name" "$context_name"
+ enable_ust_lttng_event_ok "$session_name" "$EVENT_NAME" "$chan_name"
+ start_lttng_tracing_ok "$session_name"
+
+ $TESTAPP_BIN -n "$ns" -i $NUM_EVENT -a "$file_sync_after_unshare" -b "$file_sync_before_last" &
+ app_pid=$!
+
+ # Let the app do it's thing before entering the synchronisation loop
+ sleep 0.5
+
+ while [ ! -f "$file_sync_after_unshare" ]; do
+ # Break if the app failed / died
+ if [ ! -f "/proc/$app_pid" ]; then
+ break
+ fi
+ echo "# Waiting for app..."
+ sleep 0.5
+ done
+
+ app_ns_inode=$(stat -c '%i' -L "/proc/$app_pid/ns/$ns")
+ ok $? "Get current $ns namespace inode: $app_ns_inode" || app_ns_inode="invalid"
+
+ test "$ns_inode" != "invalid" && test "$app_ns_inode" != "invalid" && test "$ns_inode" != "$app_ns_inode"
+ ok $? "Reported namespace inode changed after unshare"
+
+ touch "$file_sync_before_last"
+
+ # stop and destroy
+ stop_lttng_tracing_ok "$session_name"
+ destroy_lttng_session_ok "$session_name"
+ stop_lttng_sessiond
+
+ # Check that the events contain the right namespace inode number
+ validate_trace_count "${ns}_ns = $ns_inode" "$trace_path" $NUM_EVENT
+ validate_trace_count "${ns}_ns = $app_ns_inode" "$trace_path" $NUM_EVENT
+
+ rm -rf "$trace_path"
+ rm -f "$file_sync_before_last"
+ rm -f "$file_sync_after_unshare"
+}
+
+
+plan_tests $NUM_TESTS
+
+print_test_banner "$TEST_DESC"
+
+isroot=0
+if [ "$(id -u)" == "0" ]; then
+ isroot=1
+fi
+
+skip $isroot "Root access is needed. Skipping all tests." "$NUM_TESTS" && exit 0
+
+system_has_ns=0
+if [ -d "/proc/$$/ns" ]; then
+ system_has_ns=1
+fi
+
+skip $system_has_ns "System has no namespaces support" $NUM_TESTS && exit 0
+
+
+test_ns cgroup
+test_ns ipc
+test_ns mnt
+test_ns net
+#test_ns pid # pid_ns is special, can't be changed that way
+#test_ns user # user_ns can only be change when the app is single threaded, this is always false for an ust instrumented app
+test_ns uts
--- /dev/null
+/*
+ * Copyright (C) 2019 Michael Jeanson <mjeanson@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as published by the
+ * Free Software Foundation; version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
+ * for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this library; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+
+#include <popt.h>
+#include <sched.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <unistd.h>
+
+#include <common/compat/tid.h>
+
+#include "signal-helper.h"
+#include "utils.h"
+
+#define TRACEPOINT_DEFINE
+#include "tp.h"
+
+#define LTTNG_PROC_NS_PATH_MAX 40
+
+static int nr_iter = 100;
+static int debug = 0;
+static char *ns_opt = NULL;
+static char *after_unshare_file_path = NULL;
+static char *before_second_event_file_path = NULL;
+
+static
+struct poptOption opts[] = {
+ /* longName, shortName, argInfo, argPtr, value, descrip, argDesc */
+ { "debug", 'd', POPT_ARG_NONE, &debug, 0, "Enable debug output", NULL },
+ { "ns", 'n', POPT_ARG_STRING, &ns_opt, 0, "Namespace short identifier", NULL },
+ { "iter", 'i', POPT_ARG_INT, &nr_iter, 0, "Number of tracepoint iterations", NULL },
+ { "after", 'a', POPT_ARG_STRING, &after_unshare_file_path, 0, "after_unshare_file_path,", NULL },
+ { "before", 'b', POPT_ARG_STRING, &before_second_event_file_path, 0, "before_second_event_file_path,", NULL },
+ POPT_AUTOHELP
+ { NULL, 0, 0, NULL, 0 }
+};
+
+static void debug_printf(const char *format, ...)
+{
+ va_list args;
+ va_start(args, format);
+
+ if (debug) {
+ vfprintf(stderr, format, args);
+ }
+
+ va_end(args);
+}
+
+static int get_ns_inum(const char *ns, ino_t *ns_inum)
+{
+ int ret = 0;
+ struct stat sb;
+ char proc_ns_path[LTTNG_PROC_NS_PATH_MAX];
+
+ /*
+ * /proc/thread-self was introduced in kernel v3.17
+ */
+ if (snprintf(proc_ns_path, LTTNG_PROC_NS_PATH_MAX,
+ "/proc/thread-self/ns/%s", ns) >= 0) {
+ if (stat(proc_ns_path, &sb) == 0) {
+ *ns_inum = sb.st_ino;
+ } else {
+ ret = -1;
+ }
+ goto end;
+ }
+
+ if (snprintf(proc_ns_path, LTTNG_PROC_NS_PATH_MAX,
+ "/proc/self/task/%d/%s/net", lttng_gettid(), ns) >= 0) {
+ if (stat(proc_ns_path, &sb) == 0) {
+ *ns_inum = sb.st_ino;
+ } else {
+ ret = -1;
+ }
+ goto end;
+ }
+end:
+ return ret;
+}
+
+static int do_the_needful(int ns_flag, const char *ns_str)
+{
+ int ret = 0, i;
+ ino_t ns1, ns2;
+
+ ret = get_ns_inum(ns_str, &ns1);
+ if (ret) {
+ debug_printf("Failed to get ns inode number for namespace %s",
+ ns_str);
+ ret = -1;
+ goto end;
+ }
+ debug_printf("Initial %s ns inode number: %lu\n", ns_str, ns1);
+
+ for (i = 0; nr_iter < 0 || i < nr_iter; i++) {
+ tracepoint(tp, tptest, ns1);
+ if (should_quit) {
+ break;
+ }
+ }
+
+ ret = unshare(ns_flag);
+ if (ret == -1) {
+ perror("Failed to unshare namespace");
+ goto end;
+ }
+
+ ret = get_ns_inum(ns_str, &ns2);
+ if (ret) {
+ debug_printf("Failed to get ns inode number for namespace %s",
+ ns_str);
+ ret = -1;
+ goto end;
+ }
+ debug_printf("Post unshare %s ns inode number: %lu\n", ns_str, ns2);
+
+ /*
+ * Signal that we emited the first event group and that the
+ * unshare call is completed.
+ */
+ if (after_unshare_file_path) {
+ ret = create_file(after_unshare_file_path);
+ if (ret != 0) {
+ goto end;
+ }
+ }
+
+ /* Wait on synchronization before writing second event group. */
+ if (before_second_event_file_path) {
+ ret = wait_on_file(before_second_event_file_path);
+ if (ret != 0) {
+ goto end;
+ }
+ }
+
+ for (i = 0; nr_iter < 0 || i < nr_iter; i++) {
+ tracepoint(tp, tptest, ns2);
+ if (should_quit) {
+ break;
+ }
+ }
+
+end:
+ return ret;
+}
+
+/*
+ * Send X events, change NS, wait for file to sync with test script, send X
+ * events in new NS
+ */
+int main(int argc, const char **argv)
+{
+ int opt;
+ int ret = EXIT_SUCCESS;
+ poptContext pc;
+
+ pc = poptGetContext(NULL, argc, argv, opts, 0);
+ poptReadDefaultConfig(pc, 0);
+
+ if (argc < 2) {
+ poptPrintHelp(pc, stderr, 0);
+ ret = EXIT_FAILURE;
+ goto end;
+ }
+
+ while ((opt = poptGetNextOpt(pc)) >= 0) {
+ switch (opt) {
+ default:
+ poptPrintUsage(pc, stderr, 0);
+ ret = EXIT_FAILURE;
+ goto end;
+ }
+ }
+
+ if (opt < -1) {
+ /* An error occurred during option processing. */
+ poptPrintUsage(pc, stderr, 0);
+ fprintf(stderr, "%s: %s\n",
+ poptBadOption(pc, POPT_BADOPTION_NOALIAS),
+ poptStrerror(opt));
+ ret = EXIT_FAILURE;
+ goto end;
+ }
+
+ if (ns_opt == NULL) {
+ poptPrintUsage(pc, stderr, 0);
+ ret = EXIT_FAILURE;
+ goto end;
+ }
+
+ if (set_signal_handler()) {
+ ret = EXIT_FAILURE;
+ goto end;
+ }
+
+ if (strncmp(ns_opt, "cgroup", 3) == 0) {
+ ret = do_the_needful(CLONE_NEWCGROUP, "cgroup");
+ } else if (strncmp(ns_opt, "ipc", 3) == 0) {
+ ret = do_the_needful(CLONE_NEWIPC, "ipc");
+ } else if (strncmp(ns_opt, "mnt", 3) == 0) {
+ ret = do_the_needful(CLONE_NEWNS, "mnt");
+ } else if (strncmp(ns_opt, "net", 3) == 0) {
+ ret = do_the_needful(CLONE_NEWNET, "net");
+ } else if (strncmp(ns_opt, "pid", 3) == 0) {
+ ret = do_the_needful(CLONE_NEWPID, "pid");
+ } else if (strncmp(ns_opt, "user", 3) == 0) {
+ /*
+ * Will always fail, requires a single threaded application,
+ * which can't happen with UST.
+ */
+ ret = do_the_needful(CLONE_NEWUSER, "user");
+ } else if (strncmp(ns_opt, "uts", 3) == 0) {
+ ret = do_the_needful(CLONE_NEWUTS, "uts");
+ } else {
+ printf("invalid ns id\n");
+ ret = EXIT_FAILURE;
+ goto end;
+ }
+ ret = ret ? EXIT_FAILURE : EXIT_SUCCESS;
+end:
+ poptFreeContext(pc);
+ return ret;
+}